angular.module('koClassified.controllers.payment', [])

.controller('paymentController', ['$scope', '$cordovaToast', '$rootScope', '$cordovaInAppBrowser', '$ionicPopup', 'navigationService', 'paymentFactory', 'lodash',
                          function($scope,   $cordovaToast,   $rootScope,   $cordovaInAppBrowser,   $ionicPopup,  navigationService,   paymentFactory, _)
{

    $rootScope.main_theme = 'positive';
    $rootScope.secondary_theme = 'calm';

    $scope.paymentStart = function() {
        var data = {
            email : 'info@site.com',
            phone: '091456444654',
            price: 100
        };
        paymentFactory.startPayment(data).then(function(response){
            var defered = $q.defer();

            if(response.status) {
              var options = {
                  location: 'yes',
                  clearcache: 'yes',
                  toolbar: 'no'
              };
              $cordovaInAppBrowser.open(response.gateway_url, '_blank', options)
                  .then(function(event) {
                      // success
                  })
                  .catch(function(event) {
                      // error
                  });
            } else {
               $cordovaToast.showLongBottom(response.errors);
            }

            return defered.promise;
        });
    };

    var getQueryStrings = function(href) {
        var l = document.createElement("a");
        l.href = href;
        return l.search.substring(1);
    };
    var arrayToObject = function (array) {
      return array.reduce(function (p, c) {
        p[c[0]] = decodeURIComponent(c[1]);
        return p;
      }, {});
    };
    var fetchParamsFromUrl = function(url) {
        var query_string = getQueryStrings(url);
        var params = _.map(query_string.split('&'), function(params) {
          return params.split('=');
        });

        return arrayToObject(params);
    };

    $scope.paymentSuccessCallback = function() {
      var successPaymentPopup = $ionicPopup.show({
        templateUrl: 'templates/popups/success_payment_popup.html',
        cssClass: 'no-header-popup loading-popup success-payment-popup',
        scope: $scope,
        buttons: [{
          text: '<b>متوجه شدم</b>',
          type: 'button-energized',
          onTap: function() {
            successPaymentPopup.close();
          }
        }]
      });
    };

    $scope.paymentErrorCallback = function() {
        var failedPaymentPopup = $ionicPopup.show({
            templateUrl: 'templates/popups/failed_payment_popup.html',
            cssClass: 'no-header-popup loading-popup failed-payment-popup',
            scope: $scope,
            buttons: [{
                text: '<b>متوجه شدم</b>',
                type: 'button-energized',
                onTap: function() {
                    failedPaymentPopup.close();
                }
            }]
        });
    };

    $rootScope.$on('$cordovaInAppBrowser:exit', function(e, event){
        if(localStorage.getItem('url_scheme') !== null) {
            var url = localStorage.getItem('url_scheme');
            localStorage.removeItem('url_scheme');

            $scope.payment_data = fetchParamsFromUrl(url);
            if($scope.payment_data.payment_status === 'OK') {
                $scope.paymentSuccessCallback();
            } else {
                $scope.paymentErrorCallback();
            }
        }else{
            $scope.payment_data = {
                payment_status: 'FAILED_PAYMENT'
            };
            $scope.paymentErrorCallback();
        }
    });

}]);
