angular.module('koClassified.factories.auth', [])

.factory('authFactory', ['$q', '$http', 'APP_OPTIONS', function($q, $http, APP_OPTIONS) {
    var factory = {};

    /*
    * Sends user login data to server
    */
    factory.login = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/login', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /*
     * Sends user register data to server
     */
    factory.register = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/register', data, config);
        send.success(function(result) {
            console.log(result);
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /*
     * Sends user login data to server
     */
    factory.checkActivationCode = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/check-activation-code', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /*
     * Sends user login data to server
     */
    factory.resendActivationCode = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/resend-activation-code', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };


    /*
     * Sends user login data to server
     */
    factory.resetPassword = function(data) {
        var defered = $q.defer();

        $http({
            method: "post",
            url   :  APP_OPTIONS.api_base + '/reset-password',
            params: {
                data: data
            }
        }).success(function(result) {
            defered.resolve(result);
        }).error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };


    /*
     * Sends user login data to server
     */
    factory.changePassword = function(params) {
      var defered = $q.defer();

      var data = JSON.stringify({ data: params });
      var config = {headers : {
        'Content-Type': 'application/json'
      }};
      var send = $http.post(APP_OPTIONS.api_base + '/change-password', data, config);
      send.success(function(result) {
        defered.resolve(result);
      });
      send.error(function (error) {
        defered.reject(error);
      });

      return defered.promise;
    };

    /*
    * Fetches the user ads count data from server
    */
    factory.adsCount = function(user_token) {
        var defered = $q.defer();

        var data = JSON.stringify({ token: user_token });
        var config = {headers : {
          'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/user-ads-count', data, config);
        send.success(function(result) {
          defered.resolve(result);
        });
        send.error(function (error) {
          defered.reject(error);
        });

        return defered.promise;
    };

    factory.checkTokenExpiry = function(user_token) {
        var defered = $q.defer();

        var data = JSON.stringify({ token: user_token });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/check-token', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /*
     * Sends user login data to server
     */
    factory.loginOrRegister = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/login-or-register', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /*
     * Sends user login data to server
     */
    factory.checkForgotParam = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
          'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/check-forgot-param', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /**
     * Checks the verification code for auth forgot password
     */
    factory.checkForgotVerificationCode = function(params) {
        var defered = $q.defer();

        data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/check-forgot-verification-code', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };

    /*
     * Resets the Forgotten Password
     */
    factory.resetForgottenPassword = function(params) {
        var defered = $q.defer();

        var data = JSON.stringify({ data: params });
        var config = {headers : {
            'Content-Type': 'application/json'
        }};
        var send = $http.post(APP_OPTIONS.api_base + '/reset-password', data, config);
        send.success(function(result) {
            defered.resolve(result);
        });
        send.error(function (error) {
            defered.reject(error);
        });

        return defered.promise;
    };


    return factory;

}]);
