angular.module('koClassified.services.imageService', [])

  .service('imageService', ['$q', '$cordovaCamera', function($q, $cordovaCamera) {

      var self = this;

      /*
      * holds the option to use camera plugin
      */
      self.options = {};

      /*
      * Set the options for bringing up the camera or photo library
      *
      * @type string : camera,library | choose if you want to use the camera or pick a picture from gallery
      */
      self.setOptions = function(type) {

          self.options = {
              quality: 50,
              destinationType: Camera.DestinationType.FILE_URI,
              allowEdit: true,
              encodingType: Camera.EncodingType.JPEG,
              popoverOptions: CameraPopoverOptions,
              saveToPhotoAlbum: false,
              correctOrientation:true
          };

          if(type == 'camera') {
              self.options.sourceType = Camera.PictureSourceType.CAMERA;
          } else {
              self.options.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
          }
      };

      /*
      * Fires up camera plugin to take or choose a picture
      *
       * @type string : camera,library | choose if you want to use the camera or pick a picture from gallery
      */
      self.takePicture = function(type) {
          var defered = $q.defer();

          self.setOptions(type);
          $cordovaCamera.getPicture(self.options).then(function(imageData){
              defered.resolve(imageData);
          }, function(err) {
              console.log(err);
          });

          return defered.promise;
      };

  }]);
