angular.module('koClassified.services.payment', [])

  .service('paymentService', ['$q', '$cordovaInAppBrowser', '$rootScope', 'paymentFactory', 'authService',  function (
    $q,   $cordovaInAppBrowser,   $rootScope,   paymentFactory, authService) {
      var self = this;
      self.controllerScope = null;
      self.payment_data    = null;
      self.inAppBrowserInstance = null;

      self.setScope = function(scope) {
          self.controllerScope = scope;
      };

      self.start = function(ads_id, special_id, user_id, price, payment_type, new_plan_id) {
        self.startEvents();
        var defered = $q.defer();
        user_id = user_id || authService.token;
        var data = { ads_id: ads_id, special_id: special_id, user_id: user_id, price: price, payment_type: payment_type, new_plan_id: new_plan_id };

        paymentFactory.startPayment(data).then(function(response)
        {
          if(response.status) {
            var options = { location: 'yes', clearcache: 'yes', toolbar: 'no'};
            self.inAppBrowserInstance = $cordovaInAppBrowser.open(response.gateway_url, '_blank', options)
              .then(function(e) {
                  defered.resolve();
              })
              .catch(function(e) {
                  console.log('error in opening browser');
              });
          } else {
            //$cordovaToast.showLongBottom(response.errors);
            defered.reject(response.errors);
          }
        });

        return defered.promise;
      };

      self.getQueryStrings = function(href) {
        var l = document.createElement("a");
        l.href = href;
        return l.search.substring(1);
      };
      self.arrayToObject = function (array) {
        return array.reduce(function (p, c) {
          p[c[0]] = decodeURIComponent(c[1]);
          return p;
        }, {});
      };
      self.fetchParamsFromUrl = function(url) {
        var query_string = self.getQueryStrings(url);
        var params = _.map(query_string.split('&'), function(params) {
          return params.split('=');
        });

        return self.arrayToObject(params);
      };

    self.startEvents = function() {
      $rootScope.$on('$cordovaInAppBrowser:exit', function(e, event){
        console.log('yesss'); 
        $cordovaInAppBrowser.close();
        var url_scheme = localStorage.getItem('url_scheme');
        if(url_scheme !== null)
        {
            var url = localStorage.getItem('url_scheme');
            localStorage.removeItem('url_scheme');
            self.payment_data = self.fetchParamsFromUrl(url);
            if(self.payment_data.payment_status === 'OK') {
                self.paymentSuccessCallback();
            } else {
                self.paymentErrorCallback();
            }
        }else{
          self.payment_data = {
              payment_status: 'FAILED_PAYMENT'
          };
          self.paymentErrorCallback();
        }
      });
    };

    self.paymentSuccessCallback = function() {
        self.controllerScope.paymentSuccessCallback();
    };
    self.paymentErrorCallback = function() {
        self.controllerScope.paymentErrorCallback();
    };

    self.startEvents();
  }]);
